#include "inc/hw_memmap.h"
#include "inc/hw_types.h"

#include "driverlib/debug.h"
#include "driverlib/gpio.h"
#include "driverlib/interrupt.h"
#include "driverlib/rom.h"
#include "driverlib/rom_map.h"
#include "driverlib/sysctl.h"
#include "driverlib/systick.h"

#include "inc/lm3s3748.h"

#include <stdio.h>
#include <string.h>
#include <alloca.h>

#include "usb_cdc_driver.h"
#include "amx.h"
#include "terminal.h"

//#include "hello_dat.h"
#include "float_test_dat.h"

/* PawnVMpo͊֐ */
int amx_putstr(char* s) {
	int len = strlen(s);
	USBCDCBufferWrite( (unsigned char *)s, len);
	return len;
}

/* PawnVMpo͊֐ */
int amx_putchar(char c) {
	unsigned char outChar = c;
	USBCDCBufferWrite( &outChar, 1);
	return 1;
}

/* native֐Xg */
const AMX_NATIVE_INFO MY_Natives[] = 
{
	{ "printf"             , n_printf },
	{ NULL , NULL }        // terminator
};

/* PawnVM{ */
int amx_proc(){
	int err;
	AMX amx;
	cell ret;
	AMX_HEADER hdr;
	void *prog;

	USBCDCPrintf("Pawn VM Init\r\n");

	memcpy(&hdr, prog_data ,  sizeof(AMX_HEADER));	/* wb_[̎o */
	USBCDCPrintf("\r\nstp=%d size=%d\r\n\r\n",(int)hdr.stp,(int)hdr.size);

	if (hdr.magic != AMX_MAGIC) {
		USBCDCPrintf("ByteCode Error!!!\r\n");	/* oCgR[hs */
		return -1;
	}

	prog = alloca(hdr.stp);					/* VMp̍Ɨ̈̊m */
	memcpy(prog, prog_data ,  hdr.size);	/* vOf[^̃Rs[ */

	memset(&amx, 0, sizeof(amx));
	err = amx_Init( &amx, prog );				/* VM̏ */
	err = amx_Register(&amx, MY_Natives, -1);	/* native֐̓o^ */
	amx_FloatInit(&amx);						/* FloatW[̓o^ */
	
	USBCDCPrintf("Pawn VM Exec\r\n");
	err = amx_Exec(&amx, &ret, AMX_EXEC_MAIN);	/* VM̎s */
	amx_Cleanup(&amx);							/* VM̔j */
	
	if (err != AMX_ERR_NONE){
		USBCDCPrintf("Run time error %d\r\n", err);
	}
	else {
		USBCDCPrintf("Done!!!!\r\n");
	}

	return err;
}

int main(void)
{
	/* VXeNbN50MHzɐݒ */
	SysCtlClockSet(SYSCTL_SYSDIV_4 | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN | SYSCTL_XTAL_8MHZ);

	IntMasterEnable();
	
	/* CDC driveȑ */
	USBCDCInit();

	// ͂܂ő҂
	while(USBCDCBufferDataAvailable() ==  0);

	USBCDCPrintf("\r\nPawnVM r0 \r\n");

	amx_proc();

	USBCDCPrintf("\r\nPawnVM Stop \r\n");
	
	while(1);
}

