#include "amx.h"
#include "pawn_lm3s3748_IO.h"

#include "pawn_gpio.h"

int amx_putstr(const char* s);

void PinCodeToVarName( unsigned char pin_code , char* varName )
{
	varName[0] = 'P';
	varName[1] = (pin_code >> 4) + 'A';
	varName[2] = (pin_code & 0xF) + '0';
	varName[3] = '\0';
}

/* CꑤŐݒ肵@\ݒR[hPawnz}ṼpubNϐɏ߂ */
int SetPinFuncCode(AMX *amx, unsigned char pin_code , unsigned long func_code)
{
	char varName[4];
	cell *cPtr , amxPtr;
	int ret = -1;

	PinCodeToVarName( pin_code , varName );
	
#if defined PAWN4
	if(amx_FindPubVar(amx, varName, (cell **)(&amxPtr)) == AMX_ERR_NONE)
	{
		cPtr = amx_Address(amx , amxPtr );
		if( cPtr != NULL)
		{
			*cPtr = (pin_code << 24) | func_code ;
			ret = AMX_ERR_NONE;
		}
	}
#else
	if(amx_FindPubVar(amx, varName, &amxPtr) == AMX_ERR_NONE)
	{
		if(amx_GetAddr(amx, amxPtr, &cPtr)  == AMX_ERR_NONE)
		{
			*cPtr = (pin_code << 24) | func_code ;
			ret = AMX_ERR_NONE;
		}
	}
#endif

	return ret;
}

int amx_LM3S3748_IOInit(AMX *amx)
{
	amx_lm3s3748_GPIOInit(amx);

	return AMX_ERR_NONE;
}

int amx_LM3S3748_IOCleanup(AMX *amx)
{
	amx_lm3s3748_GPIOCleanup(amx);

	return AMX_ERR_NONE;
}
